<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      v-show="showSearch"
      label-width="68px"
    >
      <div class="query-box">
        <div class="query-box__left">
          <el-form-item label="" prop="name">
            <el-input
              v-model="queryParams.name"
              placeholder="请输入产地名称"
              clearable
              size="small"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
        </div>
        <div class="query-box__right">
          <el-form-item>
            <el-button
              type="primary"
              icon="el-icon-search"
              size="mini"
              @click="handleQuery"
              >搜索</el-button
            >
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
              >重置</el-button
            >
          </el-form-item>
        </div>
      </div>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['drugs:place:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['drugs:place:remove']"
          >批量删除</el-button
        >
      </el-col>
    </el-row>

    <el-table
      v-loading="loading"
      :data="placeList"
      @selection-change="handleSelectionChange"
      border
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column type="index" align="center" width="55" label="序号" />
      <el-table-column label="产地名称" align="center" prop="name" />
      <!-- <el-table-column label="药品id" align="center" prop="drugsId" /> -->
      <el-table-column label="省份" align="center" prop="province" />
      <!-- <el-table-column label="是否默认产地" align="center" prop="state">
        <template slot-scope="scope">
          <dict-tag :options="stateOptions" :value="scope.row.state" />
        </template>
      </el-table-column> -->
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="primary"
            style="width: 40px"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['drugs:place:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="primary"
            style="width: 40px"
            @click="handleDelete(scope.row)"
            v-hasPermi="['drugs:place:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改药品产地对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="产地名称" prop="name">
          <el-input
            v-model="form.name"
            placeholder="请输入产地名称"
            @input="handleChangeName"
          />
        </el-form-item>
        <!-- <el-form-item label="药品id" prop="drugsId">
          <el-input v-model="form.drugsId" placeholder="请输入药品id" />
        </el-form-item> -->
        <!-- <el-form-item label="省" prop="province">
          <el-input v-model="form.province" placeholder="请输入省" />
        </el-form-item> -->
        <el-form-item prop="province" label="省份">
          <el-select
            v-model="form.province"
            filterable
            placeholder="请选择省份"
            style="width: 100%"
          >
            <el-option
              v-for="item in options"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item
          label="拼音码"
          prop="params.pyq"
          v-if="form.params !== undefined"
        >
          <el-input v-model="form.params.pyq" disabled />
        </el-form-item>
        <el-form-item
          label="五笔码"
          prop="params.wb"
          v-if="form.params !== undefined"
        >
          <el-input v-model="form.params.wb" disabled />
        </el-form-item>
        <!-- <el-form-item label="是否默认" prop="state">
          <el-select
            v-model="form.state"
            placeholder="请选择状态"
            style="width: 100%"
          >
            <el-option
              v-for="dict in stateOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item> -->
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listPlace,
  getPlace,
  delPlace,
  addPlace,
  updatePlace,
  exportPlace,
} from "@/api/drugs/place";
import { getInfo } from "@/api/medical/mechanism";
import options from "@/utils/options";
export default {
  name: "Place",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 药品产地表格数据
      placeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 状态字典
      stateOptions: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        drugsId: null,
        province: null,
        state: null,
      },
      // 表单参数
      form: {
        params: {
          pyq: "",
          wb: "",
        },
        state: "N",
      },
      // 表单校验
      rules: {
        name: [
          { required: true, message: "产地名称不能为空", trigger: "blur" },
        ],
        drugsId: [
          { required: true, message: "药品id不能为空", trigger: "blur" },
        ],
        province: [{ required: true, message: "省不能为空", trigger: "blur" }],
        state: [{ required: true, message: "状态不能为空", trigger: "change" }],
        createTime: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        updateTime: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        createBy: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        updateBy: [
          { required: true, message: "状态不能为空", trigger: "blur" },
        ],
        del: [{ required: true, message: "状态不能为空", trigger: "blur" }],
      },
      options,
    };
  },
  created() {
    this.getList();
    this.getDicts("sys_yes_no").then((response) => {
      this.stateOptions = response.data;
    });
  },
  methods: {
    /** 查询药品产地列表 */
    getList() {
      this.loading = true;
      listPlace(this.queryParams).then((response) => {
        this.placeList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        drugsId: null,
        province: null,
        state: "N",
        createTime: null,
        updateTime: null,
        createBy: null,
        updateBy: null,
        del: null,
        params: {
          pyq: null,
          wb: null,
        },
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加药品产地";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getPlace(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改药品产地";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updatePlace(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPlace(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm("确定需要删除已选数据吗？", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delPlace(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有药品产地数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.exportLoading = true;
          return exportPlace(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
          this.exportLoading = false;
        })
        .catch(() => {});
    },
    //通过产地名称获取五笔、拼音
    handleChangeName(e) {
      //console.log(e);
      getInfo(e).then((res) => {
        if (res.code === 200) {
          this.$set(this.form.params, "pyq", res.data.pyq);
          this.$set(this.form.params, "wb", res.data.wb);
        }
      });
    },
  },
};
</script>
